package com.syntevo.openapi.deprecated.smartsvn.command.commit;

import org.jetbrains.annotations.*;

import com.syntevo.openapi.deprecated.smartsvn.project.*;

/**
 * @author syntevo GmbH
 *
 * @deprecated see http://www.syntevo.com/blog/?p=4160
 */
public abstract class FilterCommitPacketPhase implements ICommitPacketPhase {

	// Fields =================================================================

	private final ICommitPacketPhase wrappedPhase;

	// Setup ==================================================================

	protected FilterCommitPacketPhase(@NotNull ICommitPacketPhase wrappedPhase) {
		this.wrappedPhase = wrappedPhase;
	}

	// Implemented ============================================================

	@Override
	@NotNull
	public String getID() {
		return wrappedPhase.getID();
	}

	@Override
	@NotNull
	public ICommitPhaseUi getUi() {
		return wrappedPhase.getUi();
	}

	@Override
	public void initialize(@NotNull Project project) {
		wrappedPhase.initialize(project);
	}

	@Override
	public boolean isApplicable(@NotNull CommitPacketPhaseState state) {
		return wrappedPhase.isApplicable(state);
	}

	@Override
	public void updateFrom(@NotNull CommitPacketPhaseState state) {
		wrappedPhase.updateFrom(state);
	}

	@Override
	public void updateTo(@NotNull CommitPacketPhaseState state, @NotNull Runnable successRunnable) {
		wrappedPhase.updateTo(state, successRunnable);
	}

	@Override
	public void beforeShowing() {
		wrappedPhase.beforeShowing();
	}

	@Override
	public void cleanup(boolean cancelled) {
		wrappedPhase.cleanup(cancelled);
	}
}
