/*
 * Copyright (c) 2009 by syntevo GmbH. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  o Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  o Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 *  o Neither the name of syntevo GmbH nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package com.syntevo.openapi.deprecated.smartsvn.command.commit;

import org.eclipse.swt.widgets.*;
import org.jetbrains.annotations.*;

/**
 * The user interface for a commit phase.
 *
 * @deprecated see http://www.syntevo.com/blog/?p=4160
 */
public interface ICommitPhaseUi {

	/**
	 * Returns the name of the phase. It will be displayed in the left overview section of the commit wizard.
	 */
	@NotNull
	String getTitle();

	/**
	 * Returns the instructions of the phase. This text will be displayed above the component returned by #getComponent() in the commit wizard.
	 * @since 7.0
	 */
	@NotNull
	String getInstructions();

	/**
	 * Creates the Swing component which will be used as a wizard card. The component must not change between
	 * subsequent method invocations.
	 * @param parent
	 */
	@NotNull
	Control createComponent(@NotNull Composite parent);

	/**
	 * Returns the focusable component (as a part of getComponent()). It will be focussed when the
	 * corresponding wizard card is displayed.
	 */
	@Nullable
	Control getFocusableComponent();
}
