package com.syntevo.openapi.deprecated.smartsvn.file;

import org.jetbrains.annotations.*;

/**
 * Represents the subversion property of a file/directory.
 *
 * @deprecated see http://www.syntevo.com/blog/?p=4160
 */
public interface SvnProperty {

	// Constants ==============================================================

	String SVN_PREFIX = "svn:";
	String MERGE_INFO = SVN_PREFIX + "mergeinfo";

	// Accessing ==============================================================

	@NotNull String getName();

	/**
	 * Always returns null if isString is false.
	 */
	@Nullable String getString();

	/**
	 * Returns the bytes for both binary and string properties.
	 */
	@Nullable byte[] getBytes();

	boolean isString();

	boolean isBinary();
}
