package com.syntevo.openapi.deprecated.smartsvn.file.gui;

import org.jetbrains.annotations.*;

/**
 * A filter on SvnFiles which is added to the table's filter input field
 * popup-menu.
 *
 * @deprecated see http://www.syntevo.com/blog/?p=4160
 */
public interface ISvnFileFilter extends ISvnFileExtendedAttributeHandler {

	/**
	 * Returns the name of file filter, used to display in the popup-menu.
	 */
	@NotNull
	String getFilterName();

	/**
	 * Tests whether the specified file is matched by this filter.
	 *
	 * @param attributes the attributes to test
	 * @param text to filter text entered in the filter input field
	 * @param regularExpression true if the user has selected to filter with regular expressions
	 * @return true if the specified file is matched by this filter
	 */
	boolean doesMatch(@NotNull SvnFileExtendedAttributes attributes, @NotNull String text, boolean regularExpression);
}
